//*****************************************************************************
//*
//*
//*		GameTimer.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"GameTimer.h"
#include	"MainFrm.h"
#include	"GameTimerDoc.h"
#include	"GameTimerView.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CGameTimerApp, CWinApp)
	//{{AFX_MSG_MAP(CGameTimerApp)
	ON_COMMAND(ID_APP_ABOUT		,OnAppAbout)
	ON_COMMAND(ID_KEYSETTINGS	,OnKeySettings)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW,         CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

LOAD_LAST1(CGameTimerApp)

CGameTimerApp theApp;

//*****************************************************************************
//*
//*		CGameTimerApp
//*
//*****************************************************************************
//  CGameTimerApp Konstruktion
CGameTimerApp::CGameTimerApp()
{
}

//*****************************************************************************
//*
//*		InitInstance
//*
//*****************************************************************************
//  CGameTimerApp Initialisierung
BOOL CGameTimerApp::InitInstance()
{
LPCTSTR			pParam;
CGameTimerView *pView; 	
CDocument	   *pDoc;												
POSITION		hPos;												
int				iPos;


	AfxEnableControlContainer();


	#ifdef		_AFXDLL 				
	Enable3dControls(); 									// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
	#else
	Enable3dControlsStatic();								// Diese Funktion bei statischen MFC-Anbindungen aufrufen
	#endif

	AfxUtilityInit();

	SetRegistryKey(_T("AZ"));

	LoadStdProfileSettings();								// Standard INI-Dateioptionen laden (einschlielich MRU)


	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(IDR_MAINFRAME,RUNTIME_CLASS(CGameTimerDoc),RUNTIME_CLASS(CMainFrame),RUNTIME_CLASS(CGameTimerView));	// Haupt-SDI-Rahmenfenster
	AddDocTemplate(pDocTemplate);

	CCommandLineInfo cmdInfo;

	if(!ProcessShellCommand(cmdInfo))
		{
		return FALSE;
		}



	if(!pDocTemplate)return 0;										
		hPos=pDocTemplate->GetFirstDocPosition();					
	if(!hPos)return 0;												
		pDoc=pDocTemplate->GetNextDoc(hPos);						
	if(!pDoc)return 0;												
		hPos=pDoc->GetFirstViewPosition();							
	if(!hPos)return 0;
												

	pView = (CGameTimerView*)pDoc->GetNextView(hPos);									

	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();


	for(iPos=1;iPos<__argc;iPos++)							// Parameter auswerten
		{
		pParam = __targv[iPos];

		if(pParam[0]!='-' && pParam[0]!='/')
			{
			continue;
			}

		if(pParam[1]=='Z' || pParam[1]=='z')
			{
			m_pMainWnd->PostMessage(WM_COMMAND,ID_ZOOM);
			continue;
			}

		if(pParam[1]=='D' || pParam[1]=='d')
			{
			pView->SetDown(atoi(pParam+2));
			continue;
			}

		if(pParam[1]=='U' || pParam[1]=='u')
			{
			pView->SetDown(0);
			continue;
			}
		}
	

return TRUE;
}



//*****************************************************************************
//*
//*		OnAppAbout
//*
//*****************************************************************************
//  Anwendungsbefehl zum Ausfhren des Dialogfelds
void CGameTimerApp::OnAppAbout()
{
CDialog	sDlg(IDD_ABOUTBOX);


	sDlg.DoModal();


}

//*****************************************************************************
//*
//*		OnKeySettings
//*
//*****************************************************************************
void CGameTimerApp::OnKeySettings()
{
CDialog	sDlg(IDD_KEYSETTINGS);


	sDlg.DoModal();


}

