//*****************************************************************************
//*
//*
//*		GameTimerView.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"GameTimer.h"
#include	"GameTimerDoc.h"
#include	"GameTimerView.h"
#include	"System/ComUtility.h"
#include	<mmsystem.h>
#include	"WinAudio.h"
#include	"MainFrm.h"
#include	<math.h>

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

#ifndef 	 DC_PEN
#define		 DC_PEN				19
#endif
#ifndef 	 AC_SRC_ALPHA
#define		 AC_SRC_ALPHA       0x01
#endif

#define 	 IDC_UPDATE			0x39AE
#define 	 AUDIO_BUFFER		0x4000


extern "C"	 WINGDIAPI COLORREF WINAPI SetDCPenColor(HDC,COLORREF);


IMPLEMENT_DYNCREATE(CGameTimerView, CView)

BEGIN_MESSAGE_MAP(CGameTimerView, CView)
	//{{AFX_MSG_MAP(CGameTimerView)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_RESET					,OnReset)
	ON_COMMAND(ID_STOP1					,OnStop1)
	ON_COMMAND(ID_STOP2					,OnStop2)
	ON_COMMAND(ID_START1				,OnStart1)
	ON_COMMAND(ID_START2				,OnStart2)
	ON_COMMAND(ID_STARTBOTH				,OnStartBoth)
	ON_COMMAND(ID_SELCOMPORT			,OnSelComPort)
	ON_COMMAND(ID_USEIMAGE_A			,OnUseImageA)
	ON_COMMAND(ID_USEIMAGE_B			,OnUseImageB)
	ON_COMMAND(ID_USEIMAGE_C			,OnUseImageC)
	ON_COMMAND(ID_MINDIGITS1			,OnMinDigit1)
	ON_COMMAND(ID_MINDIGITS2			,OnMinDigit2)
	ON_COMMAND(ID_MINDIGITS3			,OnMinDigit3)
	ON_UPDATE_COMMAND_UI(ID_RESET		,OnResetUI)
	ON_UPDATE_COMMAND_UI(ID_STOP1 		,OnStop1UI)
	ON_UPDATE_COMMAND_UI(ID_STOP2 		,OnStop2UI)
	ON_UPDATE_COMMAND_UI(ID_START1 		,OnStart1UI)
	ON_UPDATE_COMMAND_UI(ID_START2 		,OnStart2UI)
	ON_UPDATE_COMMAND_UI(ID_STARTBOTH	,OnStartBothUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_A	,OnUseImageAUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_B	,OnUseImageBUI)
	ON_UPDATE_COMMAND_UI(ID_USEIMAGE_C	,OnUseImageCUI)
	ON_UPDATE_COMMAND_UI(ID_MINDIGITS1	,OnMinDigit1UI)
	ON_UPDATE_COMMAND_UI(ID_MINDIGITS2	,OnMinDigit2UI)
	ON_UPDATE_COMMAND_UI(ID_MINDIGITS3	,OnMinDigit3UI)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

DWORD	CGameTimerView::m_uLastCling;
short  *CGameTimerView::m_pBenny;
UINT	CGameTimerView::m_uBennyLen;
HRSRC	CGameTimerView::m_hBennySrc;
HGLOBAL	CGameTimerView::m_hBennyHg;
UINT	CGameTimerView::m_uAudioPos;
short  *CGameTimerView::m_aPlay[4];
UINT	CGameTimerView::m_aPlayLen[4];

extern "C"	int ComCheckPort(int iHandle);

//*****************************************************************************
//*
//*		CGameTimerView
//*
//*****************************************************************************
//  CGameTimerView Konstruktion/Destruktion
CGameTimerView::CGameTimerView()
{
CRegKeys	sKey;
int			iPort=0;


	m_iUsedImage	= 1;
	m_iWndSizeX		= 0;
	m_iWndSizeY		= 0;
	m_iNumberX		= 0;
	m_iNumberY		= 0;
	m_iAudioStop	= 0;
	m_iAudioRun		= 0;
	m_uDownMode		= 0;
	m_uDeltaTick	= 0;
	m_bStartBoth	= 1;
	m_aStart[0]		= 0;
	m_aStart[1]		= 0;
	m_aStop [0]		= 0;
	m_aStop [1]		= 0;
	m_iStop			= 0;
	m_iDone			= 0;
	m_iPort			= 0;
	m_uLastTick		= 0;
	m_iZoom			= 0;
	m_iMinMode		= 0;

	sKey.Open();
	sKey.Get(m_bStartBoth	,"StartBoth");
	sKey.Get(m_iUsedImage	,"UsedImage");
	sKey.Get(m_uDownMode	,"DownMode" );
	sKey.Get(m_iMinMode		,"MinMode"  );
	sKey.Get(iPort			,"ComPort"  );

	m_iPort = iPort;

	if(m_iUsedImage<0 || m_iUsedImage>2)m_iUsedImage=1;


}

//*****************************************************************************
//*
//*		CGameTimerView
//*
//*****************************************************************************
CGameTimerView::~CGameTimerView()
{
CRegKeys	sKey;


	sKey.Open();
	sKey.Set(m_bStartBoth	,"StartBoth");
	sKey.Set(m_iUsedImage	,"UsedImage");
	sKey.Set(m_uDownMode	,"DownMode" );
	sKey.Set(m_iMinMode		,"MinMode"  );
	sKey.Set(m_iPort		,"ComPort"  );

	while(!m_iDone)
		{
		m_iStop = 1;
		Sleep(50);
		}

}

//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CGameTimerView::PreCreateWindow(CREATESTRUCT &sCreate)
{

return CView::PreCreateWindow(sCreate);
}


//*****************************************************************************
//*
//*		Draw
//*
//*****************************************************************************
void _cdecl Draw(void *pParam,CDC *pDc,PAINTSTRUCT *pPaint)
{

	pDc->SelectStockObject(BLACK_PEN);
	pDc->SelectStockObject(DKGRAY_BRUSH);
	pDc->Rectangle(10,10,20,20);

}

//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CGameTimerView::OnCreate(LPCREATESTRUCT pCreateStruct)
{
DWORD		dwThread;
HANDLE		hThread;
LPBYTE		pData;
CRect		sRect;
UINT		uSize;
UINT		uPos;
UINT		uLen;


	if(CView::OnCreate(pCreateStruct)==-1)
		{
		return -1;
		}

	SetClassLongPtr(m_hWnd,GCLP_HBRBACKGROUND,(LPARAM)NULL);

	sRect.SetRectEmpty();
	m_cBitmapWnd.Create(WS_CHILD|WS_VISIBLE,sRect,this);
	m_cBitmapWnd.SetBkColor(RGB(0,0,0));

	UpdateNumbers();


	   m_hBennySrc=FindResourceA(NULL,"BENNY","WAVE");
	if(m_hBennySrc)
		{
		m_hBennyHg	= LoadResource  (NULL,m_hBennySrc);
		uSize		= SizeofResource(NULL,m_hBennySrc);
		pData		= (LPBYTE)LockResource(m_hBennyHg);

		for(uPos=12;uPos<4096 && uPos+16<uSize;uPos+=uLen+8)
			{
			uLen = *((DWORD*)(pData+uPos+4));
			if(memcmp(pData+uPos,"data",4))continue;
			uPos += 8;
			if(uPos+uLen>uSize)break;
			m_pBenny	 = (short*)(pData+uPos);
			m_uBennyLen = uLen/2;			
			break;
			}
		
		while(m_uBennyLen>0 && *m_pBenny==0)
			{
			m_uBennyLen--;
			m_pBenny++;
			}
		}


	m_iAudioRun	 = 1;
	AudioOpen(44100,16,1,AUDIO_BUFFER);
	AudioPause(1);
	hThread = CreateThread(NULL,0x8000,AudioThread,this,0,&dwThread);
	SetThreadPriority(hThread,THREAD_PRIORITY_HIGHEST);
	CloseHandle(hThread);


	hThread = CreateThread(NULL,0x8000,ComThread,this,0,&dwThread);
	CloseHandle(hThread);

	SetTimer(IDC_UPDATE,93,NULL);


return 0;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CGameTimerView::OnDestroy()
{
  
	AfxGetMainWnd()->ShowWindow(SW_HIDE);
	m_iAudioRun = 0;
	
	AudioStop();

	while(!m_iAudioStop)
		{
		Sleep(50);
		}

	AudioClose();


	UnlockResource(m_hBennyHg  );
	DeleteObject  (m_hBennySrc );

	CView::OnDestroy();

}

//*****************************************************************************
//*
//*		UpdateNumbers
//*
//*****************************************************************************
void CGameTimerView::UpdateNumbers()
{
const int		aImgList[]={IDB_NUMBERS_A,IDB_NUMBERS_B,IDB_NUMBERS_C};
BitmapImage	   *pImage;
BitmapImage		sImage;
int				iSize;
int				iPos;
int				iOff;
int				iNum;


	sImage.InsertBitmap(aImgList[m_iUsedImage]);
	iSize = sImage.Width()/16;

	for(iPos=0;iPos<17;iPos++)
		{
		if(iPos<15)
			{
			iOff = iSize*iPos;
			iNum = iSize;
			}
		else if(iPos==15)
			{
			iOff = iSize*iPos;
			iNum = iSize/2;
			}
		else{
			iOff = iSize*iPos-iSize/2;
			iNum = iSize/2;
			}

		m_aNumbers[iPos].Get(sImage,iOff,0,iNum,sImage.Height());
		}

	m_iNumberX	= iSize;
	m_iNumberY	= sImage.Height();

	memset(m_aList,0xFF,sizeof(m_aList));
	pImage	=  m_cBitmapWnd.GetImage();
	pImage->Box(0,0,m_iWndSizeX,m_iWndSizeY,BGR(0,0,0));

	if(m_iWndSizeX && m_iWndSizeY)RedrawWindow();

}

//*****************************************************************************
//*
//*		OnDraw
//*
//*****************************************************************************
//  CGameTimerView Zeichnen
void CGameTimerView::OnDraw(CDC *pDC)
{
CGameTimerDoc  *pDoc = GetDocument();


	ASSERT_VALID(pDoc);
}

//*****************************************************************************
//*
//*		AssertValid
//*
//*****************************************************************************
#ifdef		_DEBUG
void CGameTimerView::AssertValid() const
{
	CView::AssertValid();
}

//*****************************************************************************
//*
//*		Dump
//*
//*****************************************************************************
void CGameTimerView::Dump(CDumpContext &dc) const
{
	CView::Dump(dc);
}
#endif

//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
#ifdef		_DEBUG
CGameTimerDoc *CGameTimerView::GetDocument()
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGameTimerDoc)));

return (CGameTimerDoc*)m_pDocument;
}
#endif

//*****************************************************************************
//*
//*		OnSize
//*
//*****************************************************************************
void CGameTimerView::OnSize(UINT nType,int iSizeX,int iSizeY)
{
BitmapImage	   *pImage;


	if(iSizeX && iSizeY)
		{
		pImage	=  m_cBitmapWnd.GetImage();
		pImage->Box(0,0,iSizeX,iSizeY,BGR(0,0,0));
		memset(m_aList,0xFF,sizeof(m_aList));
		SizeWindow(&m_cBitmapWnd,iSizeX,iSizeY);
		m_iWndSizeX   = iSizeX;
		m_iWndSizeY   = iSizeY;
		}

	CView::OnSize(nType,iSizeX,iSizeY);

}

//*****************************************************************************
//*
//*		OnUpdate
//*
//*****************************************************************************
void CGameTimerView::OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint)
{



}

//*****************************************************************************
//*
//*		StartSound
//*
//*****************************************************************************
void CGameTimerView::StartSound(short *pData,unsigned uLen)
{
UINT	uIdx;

	
	
	if(!pData || !uLen || uLen>0x40000000)return;


	for(uIdx=0;uIdx<4;uIdx++)
		{
		if(m_aPlayLen[uIdx])continue;

		m_aPlay   [uIdx] = pData;
		m_aPlayLen[uIdx] = uLen;

		break;
		}


}

//*****************************************************************************
//*
//*		AudioThread
//*
//*****************************************************************************
DWORD WINAPI CGameTimerView::AudioThread(LPVOID pParam)
{
CGameTimerView *pThis=(CGameTimerView*)pParam;
short		   *pWave;
short		   *pData;
unsigned		uIdx;
unsigned		uOff;
unsigned		uLen;
int				iVal;

	m_uAudioPos = 0;

	while(pThis->m_iAudioRun)
		{
		pThis->m_sAudioSem.Lock();

			pData = (short*)AudioWritePtr();
		if(!pData)break;
		
		if(m_uAudioPos+AUDIO_BUFFER/2<m_uBennyLen)				// Benny-Klick Melodi
			{
			memcpy(pData,m_pBenny+m_uAudioPos,AUDIO_BUFFER);
			m_uAudioPos += AUDIO_BUFFER/2;
			}
		else{
			uLen = m_uBennyLen-m_uAudioPos;
			memcpy(pData,m_pBenny+m_uAudioPos,uLen*2);
			memcpy(pData+uLen,m_pBenny,AUDIO_BUFFER-uLen*2);
			m_uAudioPos = uLen;
			}
		
		for(uOff=0;uOff<AUDIO_BUFFER/2;uOff++)
			{
			pData[uOff] /= 8;
			}		
				
		for(uIdx=0;uIdx<4;uIdx++)
			{
			if(!m_aPlayLen[uIdx])continue;

			uLen  = m_aPlayLen[uIdx];
			pWave = m_aPlay   [uIdx];

			for(uOff=0;uOff<AUDIO_BUFFER/2;uOff++)
				{
				if(uOff>=uLen)break;

				iVal  = pData[uOff];
				iVal += pWave[uOff];

				if(iVal> 0x7FFF)iVal= 0x7FFF;
				if(iVal<-0x7FFF)iVal=-0x7FFF;

				pData[uOff] = iVal;
				}
			
			m_aPlayLen[uIdx] -= uOff;
			}
				
		AudioWrite(AUDIO_BUFFER);

		pThis->m_sAudioSem.Unlock();
		}


	pThis->m_iAudioStop = 1;

    
return 1;
}

//*****************************************************************************
//*
//*		StartSound
//*
//*****************************************************************************
void CGameTimerView::StartSound(LPCTSTR pSound)
{
DWORD		dwThread;
HANDLE		hThread;


	hThread = CreateThread(NULL,0x8000,WaveThread,(void*)pSound,0,&dwThread);
	CloseHandle(hThread);

}


//*****************************************************************************
//*
//*		WaveThread
//*
//*****************************************************************************
DWORD WINAPI CGameTimerView::WaveThread(LPVOID pParam)
{
LPCTSTR		pName=(LPCTSTR)pParam;
unsigned	uDiff;
unsigned	uTick;


	if(!strncmp(pName,"CLING",5))
		{
		uTick	= GetTickCount();
		uDiff	= uTick-m_uLastCling;
		if(uDiff<280)Sleep(280-uDiff);
		m_uLastCling = GetTickCount();
		}

return PlaySound(pName,AfxGetInstanceHandle(),SND_RESOURCE|SND_ASYNC);
}

//*****************************************************************************
//*
//*		OnStartBothUI
//*
//*****************************************************************************
void CGameTimerView::OnStartBothUI(CCmdUI *pCmdUI)
{

	pCmdUI->SetCheck(m_bStartBoth);

}

//*****************************************************************************
//*
//*		OnStartBoth
//*
//*****************************************************************************
void CGameTimerView::OnStartBoth()
{

	m_bStartBoth = !m_bStartBoth;

}

//*****************************************************************************
//*
//*		OnUseImage?UI
//*
//*****************************************************************************
void CGameTimerView::OnUseImageAUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iUsedImage==0);}
void CGameTimerView::OnUseImageBUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iUsedImage==1);}
void CGameTimerView::OnUseImageCUI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iUsedImage==2);}

//*****************************************************************************
//*
//*		OnUseImage?
//*
//*****************************************************************************
void CGameTimerView::OnUseImageA(){m_iUsedImage=0;UpdateNumbers();}
void CGameTimerView::OnUseImageB(){m_iUsedImage=1;UpdateNumbers();}
void CGameTimerView::OnUseImageC(){m_iUsedImage=2;UpdateNumbers();}

//*****************************************************************************
//*
//*		OnMinDigit?UI
//*
//*****************************************************************************
void CGameTimerView::OnMinDigit1UI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iMinMode==2);}
void CGameTimerView::OnMinDigit2UI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iMinMode==1);}
void CGameTimerView::OnMinDigit3UI(CCmdUI *pCmdUI){pCmdUI->SetCheck(m_iMinMode==0);}

//*****************************************************************************
//*
//*		OnMinDigit?
//*
//*****************************************************************************
void CGameTimerView::OnMinDigit1(){MinDigit(2);}
void CGameTimerView::OnMinDigit2(){MinDigit(1);}
void CGameTimerView::OnMinDigit3(){MinDigit(0);}

//*****************************************************************************
//*
//*		OnStart/StopUI
//*
//*****************************************************************************
void CGameTimerView::OnStart1UI(CCmdUI *pCmdUI){pCmdUI->Enable(m_aStart[0]==0);}
void CGameTimerView::OnStart2UI(CCmdUI *pCmdUI){pCmdUI->Enable(m_aStart[1]==0);}
void CGameTimerView::OnStop1UI (CCmdUI *pCmdUI){pCmdUI->Enable(m_aStop [0]==0 && m_aStart[0]!=0);}
void CGameTimerView::OnStop2UI (CCmdUI *pCmdUI){pCmdUI->Enable(m_aStop [1]==0 && m_aStart[1]!=0);}
void CGameTimerView::OnResetUI (CCmdUI *pCmdUI){pCmdUI->Enable(m_aStop[1]|m_aStart[1]|m_aStop[0]|m_aStart[0]);}

//*****************************************************************************
//*
//*		OnSelComPort
//*
//*****************************************************************************
void CGameTimerView::OnSelComPort()
{
char		cText[32];
int			iPort;
CTextDlg	sDlg;


	sprintf(cText,"COM%i",m_iPort+1);

	sDlg.SetText(cText);
	sDlg.SetTitle("COM-Port");
	sDlg.SetTextTitle("Bitte hier das COM-Port angeben :");
	if(sDlg.DoModal()!=IDOK)return;

	sDlg.GetText(cText,sizeof(cText));

	if(memicmp(cText,"COM",3))
		{
		iPort = strtoi(cText);
		}
	else{
		iPort = strtoi(cText+3);
		}

	m_iPort = (iPort<=0)? 0:iPort-1;

}

//*****************************************************************************
//*
//*		OnReset
//*
//*****************************************************************************
void CGameTimerView::OnReset()
{
	Reset();
}


//*****************************************************************************
//*
//*		OnStart1
//*
//*****************************************************************************
void CGameTimerView::OnStart1()
{
	Start(0,GetTickCount());
}

//*****************************************************************************
//*
//*		OnStart2
//*
//*****************************************************************************
void CGameTimerView::OnStart2()
{
	Start(1,GetTickCount());
}

//*****************************************************************************
//*
//*		OnStop1
//*
//*****************************************************************************
void CGameTimerView::OnStop1()
{
	Stop(0,GetTickCount());
}

//*****************************************************************************
//*
//*		OnStop2
//*
//*****************************************************************************
void CGameTimerView::OnStop2()
{
	Stop(1,GetTickCount());
}

//*****************************************************************************
//*
//*		MinDigit
//*
//*****************************************************************************
void CGameTimerView::MinDigit(int iDigits)
{

	m_iMinMode = iDigits;

	if(m_iWndSizeX>0 && m_iWndSizeY)
		{
		OnTimer(IDC_UPDATE);
		OnSize(0,m_iWndSizeX,m_iWndSizeY);
		RedrawWindow();
		}

}

//*****************************************************************************
//*
//*		Start
//*
//*****************************************************************************
void CGameTimerView::Start(unsigned uPlace,unsigned uTick)
{
BOOL	dDone=FALSE;


	if(uPlace>=2)return;

	if(m_bStartBoth)
		{
		if(!m_aStart[uPlace  ]){m_aStart[uPlace  ] = uTick;dDone=TRUE;}
		if(!m_aStart[uPlace^1]){m_aStart[uPlace^1] = uTick;dDone=TRUE;}
		}
	else{
		if(!m_aStart[uPlace  ]){m_aStart[uPlace  ] = uTick;dDone=(m_aStart[uPlace^1])? FALSE:TRUE;}
		}

	if(dDone)
		{
		m_sAudioSem.Lock();
		AudioStop();
		m_uAudioPos = 0;
		AudioOpen(44100,16,1,AUDIO_BUFFER);
		m_sAudioSem.Unlock();
		AudioPause(0);	
		}
	
	


}

//*****************************************************************************
//*
//*		Stop
//*
//*****************************************************************************
void CGameTimerView::Stop(unsigned uPlace,unsigned uTick)
{

	if(uPlace>=2)return;
	if(m_aStop[uPlace])return;
	m_aStop[uPlace] = uTick;
	StartSound((uPlace)? "CLING2":"CLING1");
	
	AudioPause(1);


}

//*****************************************************************************
//*
//*		Reset
//*
//*****************************************************************************
void CGameTimerView::Reset()
{
	
	AudioPause(1);
	
	m_aStart[0]		= 0;
	m_aStart[1]		= 0;
	m_aStop [0]		= 0;
	m_aStop [1]		= 0;

}

//*****************************************************************************
//*
//*		SetZoom
//*
//*****************************************************************************
void CGameTimerView::SetZoom(int iZoom)
{

	m_iZoom = iZoom;

	GetWindowRect(&m_sWndRect);
	m_sWndRect.right--;

}

//*****************************************************************************
//*
//*		SetDown
//*
//*****************************************************************************
void CGameTimerView::SetDown(int iSec)
{
	m_uDownMode = iSec;
}

//*****************************************************************************
//*
//*		OnTimer
//*
//*****************************************************************************
void CGameTimerView::OnTimer(UINT_PTR nIdEvent)
{
BitmapImage	   *pImage;
BYTE			aList[16];
CPoint			sPoint;
LPBYTE			pData;
DWORD			uTick;
DWORD			uDiff;
int				iPlace;
int				iSpaceX;
int				iSpaceY;
int				iOffX;
int				iAdd;
int				iPos;
int				iNum;


	if(nIdEvent==IDC_UPDATE)
		{
		if(!m_iWndSizeX || !m_iWndSizeY)
			{
			return;
			}

		if(m_iZoom==2)										// Cursor weg schieben bei Zoom
			{
			GetCursorPos(&sPoint);
			
			if(m_sWndRect.PtInRect(sPoint))
				{
				SetCursorPos(m_sWndRect.right,m_sWndRect.bottom-1);
				}
			}
		
		uTick	=  GetTickCount();
		pImage	=  m_cBitmapWnd.GetImage();
		iSpaceX	= (m_iWndSizeX-m_iNumberX*(18-m_iMinMode*2))/3;
		iSpaceY	= (m_iWndSizeY-m_iNumberY                  )/2;

		if(m_aStart[0] || m_aStart[1])
		if(!m_aStop[0] && !m_aStop[0])
			{
			uDiff = uTick-m_uLastTick;

			if(uDiff>=1000)
				{
				m_uLastTick = uTick;
				StartSound("TICK");
				}
	 		}

		if(m_uDownMode)
			{
			iOffX	= (m_iWndSizeX-m_iNumberX*(9-m_iMinMode))/2;
			}
		else if(iSpaceX<20)
			{
			iSpaceX = 40;
			iOffX	= 10;
			}
		else{
			iOffX	= iSpaceX;
			}


		for(iPlace=0;iPlace<2;iPlace++)
			{
			if(m_aStart[iPlace]==0)						// Luft die Anzeige
				{
				aList[9] = (BYTE)11;
				aList[8] = (BYTE)11;
				aList[7] = (BYTE)11;
				aList[6] = (BYTE)15;
				aList[5] = (BYTE)11;
				aList[4] = (BYTE)11;
				aList[3] = (BYTE)15;
				aList[2] = (BYTE)11;
				aList[1] = (BYTE)11;
				aList[0] = (BYTE)11;
				}
			else{
				if(m_uDownMode)							// Abwrts zhlen
					{
					if(m_aStop[iPlace])					// Wurde die Anzeige angehalten
						{
						uDiff = 0;
						}
					else{
						uDiff = m_uDownMode*1000-uTick+m_aStart[iPlace];
						if(uDiff==0 || uDiff&0x80000000)
							{
							Stop(iPlace,uTick);
							uDiff = 0;
							}
						}
					}
				else{
					if(m_aStop[iPlace])					// Wurde die Anzeige angehalten
							uDiff = m_aStop[iPlace]-m_aStart[iPlace];
					else	uDiff = uTick          -m_aStart[iPlace];
					}

				if(uDiff>=0x80000000)uDiff=0;

				aList[9] = (BYTE)(uDiff%10);	uDiff/=10;
				aList[8] = (BYTE)(uDiff%10);	uDiff/=10;
				aList[7] = (BYTE)(uDiff%10);	uDiff/=10;
				aList[6] = (BYTE)15;
				aList[5] = (BYTE)(uDiff%10);	uDiff/=10;

				if(uDiff){aList[4]=(BYTE)(uDiff%6);uDiff/=6;}
				else	 {aList[4]=(BYTE)10;}
				if(uDiff){aList[3]=(BYTE)15;}
				else	 {aList[3]=(BYTE)16;}

				if(uDiff){aList[2]=(BYTE)(uDiff%10);uDiff/=10;}
				else	 {aList[2]=(BYTE)10;}
				if(uDiff){aList[1]=(BYTE)(uDiff%10);uDiff/=10;}
				else	 {aList[1]=(BYTE)10;}
				if(uDiff){aList[0]=(BYTE)(uDiff%10);uDiff/=10;}
				else	 {aList[0]=(BYTE)10;}
				}

			pData	= m_aList+16*iPlace;

			for(iPos=m_iMinMode;iPos<10;iPos++,iOffX+=iAdd)
				{
				iNum = aList[iPos];
				iAdd = (iNum<15)? m_iNumberX:m_iNumberX/2;

				if(pData[iPos]==iNum)continue;

				pImage->Put(m_aNumbers[iNum],iOffX,iSpaceY);
				pData[iPos] = iNum;
				m_cBitmapWnd.InvalidateRect(iOffX,iSpaceY,iAdd,m_iNumberY);
				}

			iOffX += iSpaceX;
			
			if(m_uDownMode)break;
			}


		return;
		}

	CView::OnTimer(nIdEvent);
}


//*****************************************************************************
//*
//*		ComThread
//*
//*****************************************************************************
DWORD WINAPI CGameTimerView::ComThread(LPVOID pParam)
{
CGameTimerView *pThis=(CGameTimerView*)pParam;
char			aData[33];
int				iHandle=-1;
int				iValue;
int				iFlag;
int				iPort;
int				iDiff;
int				iPin;
int				iPos;
int				iOff;

	
	iPort = -1;
	iPos  = 0;

	while(!pThis->m_iStop)
		{
		if(iPort!=pThis->m_iPort || !ComCheckPort(iHandle))
			{
			ComClose(iHandle);
			iPort   = pThis->m_iPort;
			iHandle = ComOpen(iPort,9600);
			}

		if(iHandle<0)
			{
			Sleep(200);
			continue;
			}

		for(iOff=0;iOff<iPos;iOff++)
			{
			if(!strwchar(aData[iOff],0x00040001))
				{
				continue;
				}

			if(iOff+1<iPos)
				{
				if(aData[iOff+1]!='U')
				if(aData[iOff+1]!='S')
				if(aData[iOff+1]!='D')continue;
				}

			break;
			}

		if(iOff>0)
			{
			iPos -= iOff;
			memmove(aData,aData+iOff,iPos);
			}

		aData[iPos] = 0;
		iFlag		= 0;

		while(iPos>=3)
			{
			iOff = strwlen(aData+2,0x00040001);

			if(iOff>8)
				{
				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}


			if(iOff<8)
				{
				if(iOff+2==iPos)break;

				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}

			if(iOff==8 && iPos==10)
				{
				break;
				}

			if(iOff==8 && aData[10]!='\r' && aData[10]!='\n')
				{
				iOff += 2;
				iPos -= iOff;
				memmove(aData,aData+iOff,iPos);
				iFlag=1;
				break;
				}

			iPin	= aData[0]-'0';
			iValue	= strtoh(aData+2);

			if(aData[1]=='S' && iPin<=3)				// Synchronisierung empfangen
				{
				pThis->m_uDeltaTick = GetTickCount()-iValue;
				}
			else if(!pThis->m_uDeltaTick)				// Noch keine Synchronisierung 
				{
				pThis->m_uDeltaTick = GetTickCount()-iValue;
				}

			iValue += pThis->m_uDeltaTick;

			if(aData[1]=='D' && iPin<=4)
				{
				if(iPin==4)								
					{
					iDiff = iValue-pThis->m_uLastZoom;

					if(iDiff<0 || iDiff>100)
						{
						pThis->m_uLastZoom = iValue;
						pThis->PostMessage(WM_COMMAND,ID_ZOOM);
						}
					}

				if(iPin==3)
					{
					pThis->Reset();
					}

				if(iPin==2 && pThis->m_bStartBoth)
					{
					pThis->Start(0,iValue);
					}

				if(iPin<2 && pThis->m_aStart[iPin])
					{
					   iDiff = iValue-pThis->m_aStart[iPin];
					if(iDiff>100)pThis->Stop(iPin,iValue);
					}
				}

			if(aData[1]=='D' && iPin<2 && !pThis->m_bStartBoth)
				{
				pThis->Start(iPin,iValue);
				}


			if(aData[11]!='\n')iOff++;

			iOff += 2;
			iPos -= iOff;

			if(iPos<0 || iPos>32)iPos=0;

			memmove(aData,aData+iOff,iPos);

			if(iPos>=3)
				{
				if(aData[0]<'0'){iFlag=1;break;}
				if(aData[0]>'7'){iFlag=1;break;}
				if(aData[iOff+1]!='U')
				if(aData[iOff+1]!='S')
				if(aData[iOff+1]!='D'){iFlag=1;break;}
				}
			}

		if(iFlag)continue;


		ComWaitUntilResv(iHandle,100);
		iOff = ComGetReadCount(iHandle);
		if(iOff<=0)
			{
			if(iOff==0)continue;
			iPort=-1;
			continue;
			}

		if(iPos+iOff>32)iOff=32-iPos;
		iOff = ComRead(iHandle,aData+iPos,iOff);
		if(iOff<=0)
			{
			if(iOff==0)continue;
			iPort=-1;
			continue;
			}

		iPos += iOff;
		aData[iPos] =0;
		}


	ComClose(iHandle);
	pThis->m_iDone = 1;


return 0;
}

