//*****************************************************************************
//*
//*
//*		GameTimerView.h
//*
//*
//*****************************************************************************
#ifndef		AFX_GAMETIMERVIEW_H__77743167_0938_40FE_A1F4_64E3F5A18C4B__INCLUDED_
#define		AFX_GAMETIMERVIEW_H__77743167_0938_40FE_A1F4_64E3F5A18C4B__INCLUDED_	

#if _MSC_VER > 1000
#pragma		once						
#endif



//*****************************************************************************
//*
//*		Klasse CGameTimerView
//*
//*****************************************************************************
class CGameTimerView : public CView
{
protected:

	CGameTimerView();
	DECLARE_DYNCREATE(CGameTimerView)

public:

	CGameTimerDoc* GetDocument();

	void		 Start(unsigned uPlace,unsigned uTick);
	void		 Stop (unsigned uPlace,unsigned uTick);
	void		 SetZoom(int iZoom);
	void		 SetDown(int iSec);
	void		 Reset();


	//{{AFX_VIRTUAL(CGameTimerView)
public:
	virtual void OnDraw(CDC* pDC);								// berladen zum Zeichnen dieser Ansicht
	virtual BOOL PreCreateWindow(CREATESTRUCT &sCreate);
protected:
	//}}AFX_VIRTUAL

public:
	virtual ~CGameTimerView();
	#ifdef		_DEBUG					
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext &sDc) const;
	#endif

protected:

	BYTE			m_aList[32];
	DWORD			m_aStart[2];
	DWORD			m_aStop [2];
	BitmapImage		m_aNumbers[17];
	CBitmapWnd		m_cBitmapWnd;
	CRect			m_sWndRect;
	BOOL			m_bStartBoth;
	DWORD			m_uDeltaTick;
	DWORD			m_uDownMode;
	static DWORD	m_uLastCling;
	DWORD			m_uLastTick;
	DWORD			m_uLastZoom;
	int				m_iUsedImage;
	int				m_iNumberX;
	int				m_iNumberY;
	int				m_iWndSizeX;
	int				m_iWndSizeY;
	int				m_iMinMode;
	int				m_iZoom;
	int volatile	m_iStop;
	int volatile	m_iDone;
	int volatile	m_iPort;
	int volatile	m_iAudioRun;
	int volatile	m_iAudioStop;
	static short   *m_aPlay[4];
	static UINT		m_aPlayLen[4];
	static UINT		m_uAudioPos;
	static short   *m_pBenny;
	static UINT		m_uBennyLen;
	static HRSRC	m_hBennySrc;
	static HGLOBAL	m_hBennyHg;
	CSemaphore		m_sAudioSem;


protected:
	//{{AFX_MSG(CGameTimerView)
	afx_msg int  OnCreate(LPCREATESTRUCT pCreateStruct);
	afx_msg void OnSize(UINT nType,int iSizeX,int iSizeY);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnUseImageAUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageBUI(CCmdUI *pCmdUI);
	afx_msg void OnUseImageCUI(CCmdUI *pCmdUI);
	afx_msg void OnStartBothUI(CCmdUI *pCmdUI);
	afx_msg void OnMinDigit1UI(CCmdUI *pCmdUI);
	afx_msg void OnMinDigit2UI(CCmdUI *pCmdUI);
	afx_msg void OnMinDigit3UI(CCmdUI *pCmdUI);
	afx_msg void OnStart1UI(CCmdUI *pCmdUI);
	afx_msg void OnStart2UI(CCmdUI *pCmdUI);
	afx_msg void OnStop1UI(CCmdUI *pCmdUI);
	afx_msg void OnStop2UI(CCmdUI *pCmdUI);
	afx_msg void OnResetUI(CCmdUI *pCmdUI);
	afx_msg void OnSelComPort();
	afx_msg void OnUseImageA();
	afx_msg void OnUseImageB();
	afx_msg void OnUseImageC();
	afx_msg void OnStartBoth();
	afx_msg void OnMinDigit1();
	afx_msg void OnMinDigit2();
	afx_msg void OnMinDigit3();
	afx_msg void OnDestroy();
	afx_msg void OnStart1();
	afx_msg void OnStart2();
	afx_msg void OnStop1();
	afx_msg void OnStop2();
	afx_msg void OnReset();
	//}}AFX_MSG

	virtual void OnUpdate(CView *pSender,LPARAM lHint,CObject *pHint);

	void		 UpdateNumbers();
	void		 StartSound(LPCTSTR pSound);
	void		 StartSound(short *pData,unsigned uLen);
	void 		 MinDigit(int iDigits);


	static	DWORD WINAPI AudioThread(LPVOID pParam);
	static	DWORD WINAPI WaveThread (LPVOID pParam);
	static	DWORD WINAPI ComThread  (LPVOID pParam);
	
	DECLARE_MESSAGE_MAP()


};


//*****************************************************************************
//*
//*		GetDocument
//*
//*****************************************************************************
#ifndef		_DEBUG	
inline CGameTimerDoc *CGameTimerView::GetDocument()
{

return (CGameTimerDoc*)m_pDocument; 
}
#endif

#endif

